2 # Copyright (c) 2007, Nanako Shiraishi
4 dashless=$(basename "$0" | sed -e 's/-/ /')
5 USAGE="list [<options>]
6 or: $dashless show [<stash>]
7 or: $dashless drop [-q|--quiet] [<stash>]
8 or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9 or: $dashless branch <branchname> [<stash>]
10 or: $dashless [save [--patch] [-k|--[no-]keep-index] [-q|--quiet]
11 [-u|--include-untracked] [-a|--all] [<message>]]
22 TMP="$GIT_DIR/.git-stash.$$"
23 TMPindex=${GIT_INDEX_FILE-"$(git rev-parse --git-path index)"}.stash.$$
24 trap 'rm -f "$TMP-"* "$TMPindex"' 0
28 if git config --get-colorbool color.interactive; then
29 help_color="$(git config --get-color color.interactive.help 'red bold')"
30 reset_color="$(git config --get-color '' reset)"
37 git diff-index --quiet --cached HEAD --ignore-submodules -- &&
38 git diff-files --quiet --ignore-submodules &&
39 (test -z "$untracked" || test -z "$(untracked_files)")
43 excl_opt=--exclude-standard
44 test "$untracked" = "all" && excl_opt=
45 git ls-files -o -z $excl_opt
51 die "$(gettext "git stash clear with parameters is unimplemented")"
53 if current=$(git rev-parse --verify --quiet $ref_stash)
55 git update-ref -d $ref_stash $current
63 git update-index -q --refresh
69 # state of the base commit
70 if b_commit=$(git rev-parse --verify HEAD)
72 head=$(git rev-list --oneline -n 1 HEAD --)
74 die "$(gettext "You do not have the initial commit yet")"
77 if branch=$(git symbolic-ref -q HEAD)
79 branch=${branch#refs/heads/}
83 msg=$(printf '%s: %s' "$branch" "$head")
86 i_tree=$(git write-tree) &&
87 i_commit=$(printf 'index on %s\n' "$msg" |
88 git commit-tree $i_tree -p $b_commit) ||
89 die "$(gettext "Cannot save the current index state")"
91 if test -n "$untracked"
93 # Untracked files are stored by themselves in a parentless commit, for
94 # ease of unpacking later.
97 GIT_INDEX_FILE="$TMPindex" &&
98 export GIT_INDEX_FILE &&
100 git update-index -z --add --remove --stdin &&
101 u_tree=$(git write-tree) &&
102 printf 'untracked files on %s\n' "$msg" | git commit-tree $u_tree &&
104 ) ) || die "Cannot save the untracked files"
106 untracked_commit_option="-p $u_commit";
108 untracked_commit_option=
111 if test -z "$patch_mode"
114 # state of the working tree
116 git read-tree --index-output="$TMPindex" -m $i_tree &&
117 GIT_INDEX_FILE="$TMPindex" &&
118 export GIT_INDEX_FILE &&
119 git diff --name-only -z HEAD -- >"$TMP-stagenames" &&
120 git update-index -z --add --remove --stdin <"$TMP-stagenames" &&
124 die "$(gettext "Cannot save the current worktree state")"
128 rm -f "$TMP-index" &&
129 GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
131 # find out what the user wants
132 GIT_INDEX_FILE="$TMP-index" \
133 git add--interactive --patch=stash -- &&
135 # state of the working tree
136 w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
137 die "$(gettext "Cannot save the current worktree state")"
139 git diff-tree -p HEAD $w_tree -- >"$TMP-patch" &&
140 test -s "$TMP-patch" ||
141 die "$(gettext "No changes selected")"
143 rm -f "$TMP-index" ||
144 die "$(gettext "Cannot remove temporary index (can't happen)")"
149 if test -z "$stash_msg"
151 stash_msg=$(printf 'WIP on %s' "$msg")
153 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
155 w_commit=$(printf '%s\n' "$stash_msg" |
156 git commit-tree $w_tree -p $b_commit -p $i_commit $untracked_commit_option) ||
157 die "$(gettext "Cannot record working tree state")"
178 die "$(eval_gettext "\"$dashless store\" requires one <commit> argument")"
181 if test -z "$stash_msg"
183 stash_msg="Created via \"git stash store\"."
186 git update-ref --create-reflog -m "$stash_msg" $ref_stash $w_commit
188 test $ret != 0 && test -z "$quiet" &&
189 die "$(eval_gettext "Cannot update \$ref_stash with \$w_commit")"
208 # only default to keep if we don't already have an override
209 test -z "$keep_index" && keep_index=t
214 -u|--include-untracked)
229 # TRANSLATORS: $option is an invalid option, like
230 # `--blah-blah'. The 7 spaces at the beginning of the
231 # second line correspond to "error: ". So you should line
232 # up the second line with however many characters the
233 # translation of "error: " takes in your language. E.g. in
236 # $ git stash save --blah-blah 2>&1 | head -n 2
237 # error: unknown option for 'stash save': --blah-blah
238 # To provide a message, use git stash save -- '--blah-blah'
239 eval_gettextln "error: unknown option for 'stash save': \$option
240 To provide a message, use git stash save -- '\$option'"
250 if test -n "$patch_mode" && test -n "$untracked"
252 die "Can't use --patch and --include-untracked or --all at the same time"
257 git update-index -q --refresh
260 say "$(gettext "No local changes to save")"
263 git reflog exists $ref_stash ||
264 clear_stash || die "$(gettext "Cannot initialize stash")"
266 create_stash "$stash_msg" $untracked
267 store_stash -m "$stash_msg" -q $w_commit ||
268 die "$(gettext "Cannot save the current status")"
269 say Saved working directory and index state "$stash_msg"
271 if test -z "$patch_mode"
273 git reset --hard ${GIT_QUIET:+-q}
274 test "$untracked" = "all" && CLEAN_X_OPTION=-x || CLEAN_X_OPTION=
275 if test -n "$untracked"
277 git clean --force --quiet -d $CLEAN_X_OPTION
280 if test "$keep_index" = "t" && test -n "$i_tree"
282 git read-tree --reset -u $i_tree
285 git apply -R < "$TMP-patch" ||
286 die "$(gettext "Cannot remove worktree changes")"
288 if test "$keep_index" != "t"
296 git rev-parse --verify --quiet $ref_stash >/dev/null
300 have_stash || return 0
301 git log --format="%gd: %gs" -g --first-parent -m "$@" $ref_stash --
305 ALLOW_UNKNOWN_FLAGS=t
306 assert_stash_like "$@"
310 if test "$(git config --bool stash.showStat || echo true)" = "true"
315 if test "$(git config --bool stash.showPatch || echo false)" = "true"
317 FLAGS=${FLAGS}${FLAGS:+ }-p
326 git diff ${FLAGS} $b_commit $w_commit
335 # Parses the remaining options looking for flags and
336 # at most one revision defaulting to ${ref_stash}@{0}
339 # Derives related tree and commit objects from the
340 # revision, if one is found.
342 # stash records the work tree, and is a merge between the
343 # base commit (first parent) and the index tree (second parent).
345 # REV is set to the symbolic version of the specified stash-like commit
346 # IS_STASH_LIKE is non-blank if ${REV} looks like a stash
347 # IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
348 # s is set to the SHA1 of the stash commit
349 # w_commit is set to the commit containing the working tree
350 # b_commit is set to the base commit
351 # i_commit is set to the commit containing the index tree
352 # u_commit is set to the commit containing the untracked files tree
353 # w_tree is set to the working tree
354 # b_tree is set to the base tree
355 # i_tree is set to the index tree
356 # u_tree is set to the untracked files tree
358 # GIT_QUIET is set to t if -q is specified
359 # INDEX_OPTION is set to --index if --index is specified.
360 # FLAGS is set to the remaining flags (if allowed)
363 # * too many revisions specified
364 # * no revision is specified and there is no stash stack
365 # * a revision is specified which cannot be resolve to a SHA1
366 # * a non-existent stash reference is specified
367 # * unknown flags were set and ALLOW_UNKNOWN_FLAGS is not "t"
370 parse_flags_and_rev()
372 test "$PARSE_CACHE" = "$*" && return 0 # optimisation
388 REV=$(git rev-parse --no-flags --symbolic --sq "$@") || exit 1
404 test "$ALLOW_UNKNOWN_FLAGS" = t ||
405 die "$(eval_gettext "unknown option: \$opt")"
406 FLAGS="${FLAGS}${FLAGS:+ }$opt"
415 have_stash || die "$(gettext "No stash found.")"
416 set -- ${ref_stash}@{0}
422 die "$(eval_gettext "Too many revisions specified: \$REV")"
426 REV=$(git rev-parse --symbolic --verify --quiet "$1") || {
428 die "$(eval_gettext "\$reference is not a valid reference")"
431 i_commit=$(git rev-parse --verify --quiet "$REV^2") &&
432 set -- $(git rev-parse "$REV" "$REV^1" "$REV:" "$REV^1:" "$REV^2:" 2>/dev/null) &&
440 test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
443 u_commit=$(git rev-parse --verify --quiet "$REV^3") &&
444 u_tree=$(git rev-parse "$REV^3:" 2>/dev/null)
449 parse_flags_and_rev "$@"
450 test -n "$IS_STASH_LIKE"
453 assert_stash_like() {
454 is_stash_like "$@" || {
456 die "$(eval_gettext "'\$args' is not a stash-like commit")"
461 is_stash_like "$@" && test -n "$IS_STASH_REF"
465 is_stash_ref "$@" || {
467 die "$(eval_gettext "'\$args' is not a stash reference")"
473 assert_stash_like "$@"
475 git update-index -q --refresh || die "$(gettext "unable to refresh index")"
477 # current index state
478 c_tree=$(git write-tree) ||
479 die "$(gettext "Cannot apply a stash in the middle of a merge")"
481 unstashed_index_tree=
482 if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
483 test "$c_tree" != "$i_tree"
485 git diff-tree --binary $s^2^..$s^2 | git apply --cached
487 die "$(gettext "Conflicts in index. Try without --index.")"
488 unstashed_index_tree=$(git write-tree) ||
489 die "$(gettext "Could not save index tree")"
495 GIT_INDEX_FILE="$TMPindex" git-read-tree "$u_tree" &&
496 GIT_INDEX_FILE="$TMPindex" git checkout-index --all &&
498 die 'Could not restore untracked files from stash'
502 GITHEAD_$w_tree='Stashed changes' &&
503 GITHEAD_$c_tree='Updated upstream' &&
504 GITHEAD_$b_tree='Version stash was based on' &&
505 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
508 if test -n "$GIT_QUIET"
510 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
512 if git merge-recursive $b_tree -- $c_tree $w_tree
515 if test -n "$unstashed_index_tree"
517 git read-tree "$unstashed_index_tree"
520 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
521 git read-tree --reset $c_tree &&
522 git update-index --add --stdin <"$a" ||
523 die "$(gettext "Cannot unstage modified files")"
527 if test -n "$GIT_QUIET"
529 squelch='>/dev/null 2>&1'
531 (cd "$START_DIR" && eval "git status $squelch") || :
533 # Merge conflict; keep the exit status from merge-recursive
536 if test -n "$INDEX_OPTION"
538 gettextln "Index was not unstashed." >&2
545 assert_stash_ref "$@"
552 say "The stash is kept in case you need it again."
558 assert_stash_ref "$@"
560 git reflog delete --updateref --rewrite "${REV}" &&
561 say "$(eval_gettext "Dropped \${REV} (\$s)")" ||
562 die "$(eval_gettext "\${REV}: Could not drop stash entry")"
564 # clear_stash if we just dropped the last stash entry
565 git rev-parse --verify --quiet "$ref_stash@{0}" >/dev/null ||
570 test -n "$1" || die "$(gettext "No branch name specified")"
575 assert_stash_like "$@"
577 git checkout -b $branch $REV^ &&
578 apply_stash "$@" && {
579 test -z "$IS_STASH_REF" || drop_stash "$@"
583 PARSE_CACHE='--not-parsed'
584 # The default command is "save" if nothing but options are given
590 *) seen_non_option=t; break ;;
594 test -n "$seen_non_option" || set "save" "$@"
620 create_stash "$*" && echo "$w_commit"
642 say "$(gettext "(To restore them type \"git stash apply\")")"